<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006 Popy (popy.dev@gmail.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * tx_ppstats_tsfehook class
 *
 * @author Popy <popy.dev@gmail.com>
 */



class tx_ppstats_tsfehook {
	var $site_index=0;

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function main($param) {
		/* Declare */
		global $TSFE;
	
		/* Begin */
		$this->site_index=intval($TSFE->tmpl->setup['config.']['site_index']);
		if ($GLOBALS['PP_STATS_TSFEHOOK']['alreadyStarted']) return FALSE;
		$GLOBALS['PP_STATS_TSFEHOOK']['alreadyStarted']=TRUE;

		$this->trackUser();
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function addPageAccess($userId) {
		/* Declare */
		global $TYPO3_DB,$TSFE;
	
		/* Begin */
		$TYPO3_DB->exec_INSERTquery(
			'tx_ppstats_pageaccess',
			array(
				'pid'=>$TSFE->id,
				'user_id'=>$userId,
				'crdate'=>$this->getTime(),
				'site_index'=>$this->site_index,
				'get_params'=>serialize(t3lib_div::_GET()),
				'url'=>t3lib_div::getIndpEnv('REQUEST_URI'),
				'abs_url'=>t3lib_div::getIndpEnv('TYPO3_REQUEST_URL'),
				'title'=>$GLOBALS['TSFE']->page['title']
				)
			);
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function trackUser() {
		/* Declare */
		global $TYPO3_DB,$TSFE;
		$data=array();
		$clientInfos=array();
		$clientKey='';
		$pageId=$TSFE->id;

		$curHost=t3lib_div::getIndpEnv('HTTP_HOST');
		$referer=t3lib_div::getIndpEnv('HTTP_REFERER');
		$refererData=parse_url($referer);
	
		/* Begin */

		//** Check if current user is comming from the website
		//     if referer is empty, it's maybe because :
		//        - User has reload the page              <- we keep clientKey, perfect :)
		//        - a paranoiac Proxy has deleted it (!)  <- ... trust in SESSION and clientKey
		//        - user has entered manually the adress  <- SESSION may have expired :)
		if (trim($referer) && !stripos(' '.$referer,$curHost) && !($curHost==$refererData['host'])) {
			//* User is coming from another site : Force recording referer
			$this->setClientKey(0);
		}

		if (!($clientKey=$this->getClientKey())) {
			//** We have a new user :)
			header('Message: Welcome !');
		}

		if ($clientKey && ($clientInfos=$this->getClientInfo($clientKey))) {
			//** Just need to update some infos
			$data['lastconnection']=$this->getTime();
		
		} else {
			//*** Building all infos
			$data['site_index']=$this->site_index;
			$data['client_ip']=t3lib_div::getIndpEnv('REMOTE_ADDR');
			$data['firstconnection']=$this->getTime();
			$data['lastconnection']=$this->getTime();
			$data['accept_language']=$_SERVER['HTTP_ACCEPT_LANGUAGE'];
			$data['referer_full']=$referer;
			$data['referer_resolved']=$refererData['host'];
			$data['user_agent']=t3lib_div::getIndpEnv('HTTP_USER_AGENT');
			$data['user_agent_resolved']='';

			if (stripos($data['user_agent'],'MSIE ')) {
				// MSIE browser
				list(,$temp)=explode(';',$data['user_agent']);
				$temp=end(explode(' ',$temp));
				$data['user_agent_resolved']='MSIE;'.trim($temp).';';
			} elseif ((stripos(' '.$data['user_agent'],'Mozilla')==1) && stripos($data['user_agent'],'compatible')) {
				//Others Mozilla 'compatible' (...)
				list(/*Mozilla*/,/*compatible*/,$temp)=explode(' ',$data['user_agent']);
				list($data['user_agent_resolved'],$version)=split('[; /]',$temp);
				$data['user_agent_resolved']='Mozilla-compatible: '.$data['user_agent_resolved'].';'.$version.';';
			} elseif ($temp=stripos($data['user_agent'],'Firefox')) {
				//Firefox :)
				list(,$temp)=explode('/',substr($data['user_agent'],$temp));
				$data['user_agent_resolved']='Firefox;'.$temp.';';
			} elseif ($temp=stripos($data['user_agent'],'Safari')) {
				//Safari
				list(,$temp)=explode('/',substr($data['user_agent'],$temp));
				$data['user_agent_resolved']='Safari;'.$temp.';';
			} elseif ($temp=stripos($data['user_agent'],'Opera')) {
				//Opera (masked)
				list(,$temp)=explode('/',substr($data['user_agent'],$temp));
				$data['user_agent_resolved']='Opera;'.$temp.';';
			} else {
				//Others
				$temp=reset(explode(' ',$data['user_agent']));
				list($browser,$version,$url)=explode('/',$temp);
				$data['user_agent_resolved']=$browser.';'.$version.';';
			}

			$regs=Array();
			if (ereg('https?://[-a-z0-9_\/&\?=.%+]+',$data['user_agent'],$regs)) {
				$data['user_agent_resolved'].=reset($regs);
			}
		}

		if (intval($GLOBALS['TSFE']->fe_user->user['uid'])) $data['fe_user']=intval($GLOBALS['TSFE']->fe_user->user['uid']);

		if (is_array($clientInfos) && count($clientInfos)) {
			$TYPO3_DB->exec_UPDATEquery('tx_ppstats_usertrack','uid='.intval($clientKey),$data);
		} else {
			if ($TYPO3_DB->exec_INSERTquery('tx_ppstats_usertrack',$data)) {
				$this->setClientKey($TYPO3_DB->sql_insert_id());
			}
		}

		$this->addPageAccess($this->getClientKey());
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function setClientKey($key) {
		$GLOBALS['TSFE']->fe_user->setKey('ses','pp_stats/trackUser',$key);
		return $key;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function getClientKey() {
		return $GLOBALS['TSFE']->fe_user->getKey('ses','pp_stats/trackUser');
	}


	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function getClientInfo($clientKey,$fields='*') {
		/* Declare */
		global $TYPO3_DB;
	
		/* Begin */
		if (!$clientKey) return FALSE;
		if ($res=$TYPO3_DB->exec_SELECTgetRows($fields,'tx_ppstats_usertrack','uid='.intval($clientKey))) {
			return reset($res);
		}
		return FALSE;
	}

	function getTime() {
		return $GLOBALS['SIM_EXEC_TIME'];
	}
}

if (!function_exists('stripos')) {
	function stripos($haystack, $needle, $offset=0) {
		return strpos(strtolower($haystack), strtolower($needle), $offset);
	}
}


global $TYPO3_CONF_VARS;
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pp_stats/class.tx_ppstats_tsfehook.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pp_stats/class.tx_ppstats_tsfehook.php']);
}

?>