<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Popy (popy.dev@gmail.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Module extension (addition to function menu) 'Statistiques d'accs' for the 'pp_stats' extension.
 *
 * @author	Popy <popy.dev@gmail.com>
 */



require_once(PATH_t3lib.'class.t3lib_extobjbase.php');


//*** Thanks to Kasper Ligaard Nielsen for this part
if (@is_dir(PATH_site.'typo3/sysext/cms/tslib/')) {
	define('PATH_tslib', t3lib_extMgm::extPath('cms').'tslib/');
} elseif (@is_dir(PATH_site.'tslib/')) {
	define('PATH_tslib', PATH_site.'tslib/');
} else {

	// define path to tslib/ here:
	$configured_tslib_path = '';

	// example:
	// $configured_tslib_path = '/var/www/mysite/typo3/sysext/cms/tslib/';

	define('PATH_tslib', $configured_tslib_path);
}

if (PATH_tslib=='') {
	die('Cannot find tslib/. Please set path by defining $configured_tslib_path in '.basename(PATH_thisScript).'.');
}

require_once(PATH_tslib.'class.tslib_fe.php');

	require_once(PATH_t3lib.'class.t3lib_tstemplate.php');
	require_once(PATH_t3lib.'class.t3lib_timetrack.php');
	require_once(PATH_tslib.'class.tslib_content.php');
	require_once(PATH_t3lib.'class.t3lib_tsparser_ext.php');
	require_once(PATH_t3lib.'class.t3lib_page.php');

class tx_ppstats_modfunc1 extends t3lib_extobjbase {
	var $site_index=0;

	function modMenu()	{
		global $LANG;

		return array (
			'pp_stats_type' => array(
				'period'=>$this->getLL('menu.perPeriod'),
				'periodPage'=>$this->getLL('menu.perPeriodPerPage'),
				'detail'=>$this->getLL('menu.detail'),
				'mostVisited'=>$this->getLL('menu.mostVisited'),
				'referer'=>$this->getLL('menu.referer')
				)
			);
	}

	function main()	{
			// Initializes the module. Done in this function because we may need to re-initialize if data is submitted!
		global $SOBE,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		$this->pid=$this->pObj->id;

		$this->buildTSFE();
		$this->site_index=intval($GLOBALS['TSFE']->tmpl->setup['config.']['site_index']);

		$this->data=t3lib_div::_GP('data');
		//$this->init();

		if (!$this->pid) {
			$this->pid=intval($this->data['keepPid']);
		}

		$this->_addParams='&data[keepPid]='.$this->pid;

		$content=$this->printMenu();

		switch ($this->pObj->MOD_SETTINGS['pp_stats_type']){
		case 'period': 
			$content.=$this->printPeriod();
			break;
		case 'periodPage': 
			$content.=$this->printPeriodPage();
			break;
		case 'detail':
			$content.=$this->printDetail();
			break;
		case 'mostVisited':
			$content.=$this->printMostVisited();
			break;
		case 'referer':
			$content.=$this->printReferer();
			break;
		}
		
		return $content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function print_filters($options=Array()) {
		/* Declare */
		$content='
		<div class="filter-container bgColor2">
			<h3><img alt="" '.t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'],'gfx/helpbubble.gif','',0).' /> '.$this->getLL('period.formLabel').'</h3>';
		$this->filters=Array();
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	
		$columns=Array(
			'left'=>Array(),
			'right'=>Array()
			);
	
		/* Begin */
		$this->pObj->doc->inDocStyles.='
body .filter-container {
	background-color: transparent;
}
body .filter-container h3 {
	background-color: transparent;
	padding: 0px;
	margin: 3px;
}

.filter-container .row {
	overflow: hidden;
	padding: 10px;
}
.filter-container .left-col {
	overflow: hidden;
	float: left;
	width: 240px;
}
.filter-container .right-col {
	margin-left: 245px;
}
.filter-container .label {
	width: 125px;
	float: left;
}
';

		foreach ($options as $partKey) {
			switch ($partKey){
			case 'starttime':
				//** Get a correct value
				if (isset($this->data['starttime']) && trim($this->data['starttime'])) {
					list($day,$month,$year)=explode('/',$this->data['starttime']);
					$this->filters['starttime']=mktime(0,0,0,$month,$day,$year);
				}
				if (!isset($this->filters['starttime']) || !isset($this->filters['starttime'])) {
					$this->filters['starttime']=$currentDay;
				}
				$columns['left'][]='<div class="label">'.$this->getLL('filters.start').'</div> <input type="text" name="data[starttime]" value="'.htmlspecialchars(date('d/m/Y',$this->filters['starttime'])).'" class="push-right" />';
				break;
			case 'endtime':
				//** Get a correct value
				if (isset($this->data['endtime']) && trim($this->data['endtime'])) {
					list($day,$month,$year)=explode('/',$this->data['endtime']);
					$this->filters['endtime']=mktime(0,0,0,$month,$day,$year);
				}
				if (!isset($this->filters['endtime']) || !$this->filters['endtime']) {
					$this->filters['endtime']=$currentDay+(24*3600);
				}
				$columns['left'][]='<div class="label">'.$this->getLL('filters.stop').'</div> <input type="text" name="data[endtime]" value="'.htmlspecialchars(date('d/m/Y',$this->filters['endtime'])).'" class="push-right" />';
				break;
			case 'step':
				$this->filters['step']=isset($this->data['step'])?$this->data['step']:1;
				$columns['left'][]='<div class="label">'.$this->getLL('filters.step').'</div> <input type="text" name="data[step]" value="'.htmlspecialchars($this->filters['step']).'" class="push-right" />';
				break;
			case 'graph':
				$this->filters['graph']=isset($this->data['graph'])?$this->data['graph']:0;
				$columns['right'][]='<div class="label">'.$this->getLL('filters.asGraph').'</div> <input type="checkbox" name="data[graph]_"'.($this->filters['graph']?' checked="checked"':'').' class="push-right" onchange="this.form.elements[\'data[graph]\'].value=this.checked?1:0;" /><input type="hidden" name="data[graph]" value="'.$this->filters['graph'].'" />';
				break;
			case 'step2':
				$this->filters['step2']=(isset($this->data['step2']) && in_array(intval($this->data['step2']),array(1,2,3,4,6,8,12,24)))?intval($this->data['step2']):4;
				$temp='<div class="label">'.$this->getLL('filters.step2').'</div> <select name="data[step2]">';
				foreach (array(1,2,3,4,6,8,12,24) as $val) {
					$temp.='<option value="'.$val.'"'.(($val==$this->filters['step2'])?' selected="selected"':'').'>'.$val.' h</option>';
				}
				$temp.='</select>';
				$columns['left'][]=$temp;
				break;
			}
		}

		$columns['right'][]='<input type="submit" value="&gt;" />';
		$content.='
			<div class="row">
				<div class="left-col"><div>'.implode('</div><div>',$columns['left']).'</div></div>
				<div class="right-col"><div>'.implode('</div><div>',$columns['right']).'</div></div>
			</div>
		</div>';


		return $content;
	}

	/******************************************/
	/**************  Period part  *************/
	/******************************************/

	/**
	 * Print the period-stat table
	 *
	 * @access public
	 * @return string 
	 */
	function printPeriod() {
		/* Declare */
		$content='';
		$startTime=0;
		$endTime=0;
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	

		/* Begin */
		//$content.=$this->print_filters(Array('starttime','endtime','step','graph','step2'));
		$content.='<div>';

		//*** getting data
		if (trim($this->data['start'])) {
			list($day,$month,$year)=explode('/',$this->data['start']);
			$startTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$startTime) {
			$this->data['start']=date('d/m/Y',$this->getTime());
			$startTime=$currentDay;
		}

		if (trim($this->data['stop'])) {
			list($day,$month,$year)=explode('/',$this->data['stop']);
			$endTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$endTime) {
			$this->data['stop']=date('d/m/Y',$currentDay+(24*3600));
			$endTime=$currentDay+(24*3600);
		}

		if (!($step=intval($this->data['step']))) $step=1;
		$this->data['step']=$step;

		//*** printing form
		$content.='<h3>'.$this->getLL('period.formLabel').'</h3>';
		$content.='<table>';
		$content.='<tr><td>'.$this->getLL('period.start').'</td><td><input type="text" name="data[start]" value="'.htmlspecialchars($this->data['start']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('period.stop').'</td><td><input type="text" name="data[stop]" value="'.htmlspecialchars($this->data['stop']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('period.step').'</td><td><input type="text" name="data[step]" value="'.htmlspecialchars($this->data['step']).'" /></td></tr>';
		$content.='<tr><td><input type="submit" value="&gt;" /></td><td>&nbsp;</td>';
		$content.='</table>';

		//*** Printing presets
		$content.='<h3>'.$this->getLL('period.presets').'</h3>';
		$linkTmpl='<a href="index.php?id='.htmlentities($this->id.'&data[start]=###start###&data[stop]=###stop###&data[step]=###step###'.$this->_addParams).'">###label###</a><br />';
		foreach ($this->getPresets() as $val) {
			$val=array_map('htmlspecialchars',$val);
			$content.=str_replace(array_keys($val),array_values($val),$linkTmpl);
		}

		//*** Printing stats table
		$content.='<h3>'.$this->getLL('period.stats').'</h3>';
		$temp=array();
		$counter=0;
		$tables=array();
		$isFirst=TRUE;
		foreach ($this->renderNbVisitsPerPeriod($startTime,$endTime,$step*3600*24) as $key=>$val) {
			list($date,)=explode(';',$key);
			//** Filling beginning of first row (a row starts with Monday, even if we have no data for it
			if ($isFirst && intval(date('w',$date))) {
				for ($i=1;$i<intval(date('w',$date));$i++) {
					$temp['row1'].='<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
					$temp['row2'].='<td></td>';
					$temp['row3'].='<td></td>';
					$counter++;
				}
			}
			$isFirst=FALSE;

			//** Record current stat in temp array
			$temp['row1'].='<td style="background: '.$this->pObj->doc->bgColor2.';">'.date('d/m/Y',$date).'</td>';
			$temp['row2'].='<td style="background: '.$this->pObj->doc->bgColor4.';">'.$val['user'].'</td>';
			$temp['row3'].='<td style="background: '.$this->pObj->doc->bgColor4.';">'.$val['pages'].'</td>';
			$counter++;

			//** If current day is monday, adding $temp array to the final array
			if (!$isFirst && (intval(date('w',$date))==0)) {
				$tables[]=$temp;
				$counter=0;
				$temp=array();
			}
		}

		//** If $temp array isn't empty, adding it
		if ($counter) {
				for ($i=$counter;$i<7;$i++) {
					$temp['row1'].='<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>';
					$temp['row2'].='<td></td>';
					$temp['row3'].='<td></td>';
				}
			$tables[]=$temp;
		}

		$content.='<table>';
		foreach ($tables as $val) {
			$content.='<tr><td>&nbsp;</td>'.$val['row1'].'</tr>';
			$content.='<tr><td style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('period.users').'</td>'.$val['row2'].'</tr>';
			$content.='<tr><td style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('period.pages').'</td>'.$val['row3'].'</tr>';
		}
		$content.='</table>';

		$content.='</div>';

		return $content;
	}


	/**
	 * 
	 *
	 * @access public
	 * @return string 
	 */
	function printPeriodPage() {
		/* Declare */
		$content='<div>';
		$startTime=0;
		$endTime=0;
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	

		/* Begin */

		//*** getting data
		if (trim($this->data['start'])) {
			list($day,$month,$year)=explode('/',$this->data['start']);
			$startTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$startTime) {
			$this->data['start']=date('d/m/Y',$this->getTime());
			$startTime=$currentDay;
		}

		if (trim($this->data['stop'])) {
			list($day,$month,$year)=explode('/',$this->data['stop']);
			$endTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$endTime) {
			$this->data['stop']=date('d/m/Y',$currentDay+(24*3600));
			$endTime=$currentDay+(24*3600);
		}

		//*** printing form
		$content.='<h3>'.$this->getLL('period.formLabel').'</h3>';
		$content.='<table>';
		$content.='<tr><td>'.$this->getLL('period.start').'</td><td><input type="text" name="data[start]" value="'.htmlspecialchars($this->data['start']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('period.stop').'</td><td><input type="text" name="data[stop]" value="'.htmlspecialchars($this->data['stop']).'" /></td></tr>';
		$content.='<tr><td><input type="submit" value="&gt;" /></td><td>&nbsp;</td>';
		$content.='</table>';

		//*** Printing presets
		$content.='<h3>'.$this->getLL('period.presets').'</h3>';
		$linkTmpl='<a href="index.php?id='.htmlentities($this->id.'&data[start]=###start###&data[stop]=###stop###&data[step]=###step###'.$this->_addParams).'">###label###</a><br />';
		foreach ($this->getPresets() as $val) {
			$val=array_map('htmlspecialchars',$val);
			$content.=str_replace(array_keys($val),array_values($val),$linkTmpl);
		}

		//*** Printing stats table
		$content.='<h3>'.$this->getLL('periodPage.stats').'</h3>';

		$result=FALSE;
		$nbVisites=array();

		if (intval($this->pid)) {
			$result=$GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'count(*) AS acces',
				'tx_ppstats_pageaccess',
				'pid='.intval($this->pid).' AND crdate>='.$startTime.' AND crdate<'.$endTime,
				'',
				'',
				1
				);

			if ($result) $result=reset($result);
			if ($result) $nbVisites['single']=$result['acces'];

			$pidList=$this->getPidList($this->pid);

			$result=$GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'count(*) AS acces',
				'tx_ppstats_pageaccess',
				'pid IN ('.implode(',',$pidList).') AND crdate>='.$startTime.' AND crdate<'.$endTime,
				'',
				'',
				1
				);

			if ($result) $result=reset($result);
			if ($result) $nbVisites['pidlist']=$result['acces'];

		}

		$content.='<table><tr>';
		$content.='<td style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('periodPage.thisPage').'</td>';
		$content.='<td style="background: '.$this->pObj->doc->bgColor4.';">'.((string)$nbVisites['single']).'</td>';
		$content.='</tr><tr>';
		$content.='<td style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('periodPage.subPages').' ('.((string)count($pidList)).')</td>';
		$content.='<td style="background: '.$this->pObj->doc->bgColor4.';">'.((string)$nbVisites['pidlist']).'</td>';
		$content.='</tr></table>';


		return $content.'</div>';

	}


	/**
	 * Building a stat-array between two date
	 *
	 * @param int $starttime (unix timestamp)
	 * @param int $endtime (unix timestamp)
	 * @param int $period (unix timestamp) step size
	 * @access public
	 * @return array 
	 */
	function renderNbVisitsPerPeriod($starttime,$endtime,$period) {
		/* Declare */
		$data=array();
		global $TYPO3_DB;
	
		/* Begin */
		while ($starttime<$endtime) {

			$res=$TYPO3_DB->exec_SELECTgetRows(
				'tx_ppstats_usertrack.uid,count(*) AS counter',
				'tx_ppstats_usertrack LEFT JOIN tx_ppstats_pageaccess ON (tx_ppstats_pageaccess.user_id=tx_ppstats_usertrack.uid)',
				'tx_ppstats_usertrack.site_index='.$this->site_index.' AND tx_ppstats_usertrack.firstconnection>='.$starttime.' AND tx_ppstats_usertrack.firstconnection<'.min($starttime+$period,$endtime),
				'tx_ppstats_usertrack.uid'
				);

			$temp=array('user'=>0,'pages'=>0);
			foreach ($res as $val) {
				$temp['user']++;
				$temp['pages']+=$val['counter'];
			}

			$data[$starttime.';'.$endtime]=$temp;
			$starttime+=$period;
		}

		return $data;
	}



	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function printReferer() {
		/* Declare */
		$content='';
		$startTime=0;
		$endTime=0;
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	
		global $TYPO3_DB;
	
		/* Begin */
		if (trim($this->data['start'])) {
			list($day,$month,$year)=explode('/',$this->data['start']);
			$startTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$startTime) {
			$this->data['start']=date('d/m/Y',$this->getTime());
			$startTime=$currentDay;
		}

		if (trim($this->data['stop'])) {
			list($day,$month,$year)=explode('/',$this->data['stop']);
			$endTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$endTime) {
			$this->data['stop']=date('d/m/Y',$currentDay+(24*3600));
			$endTime=$currentDay+(24*3600);
		}


		$content.='<h3>'.$this->getLL('referer.formLabel').'</h3>';
		$content.='<table>';
		$content.='<tr><td>'.$this->getLL('referer.start').'</td><td><input type="text" name="data[start]" value="'.htmlspecialchars($this->data['start']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('referer.stop').'</td><td><input type="text" name="data[stop]" value="'.htmlspecialchars($this->data['stop']).'" /></td></tr>';
		$content.='<tr><td><input type="submit" value="&gt;" /></td><td>&nbsp;</td>';
		$content.='</table>';

		$content.='<h3>'.$this->getLL('referer.presets').'</h3>';

		$linkTmpl='<a href="index.php?id='.$this->id.'&data[start]=###start###&data[stop]=###stop###&data[step]=###step###">###label###</a><br />';


		foreach ($this->getPresets() as $val) {
			$val=array_map('htmlspecialchars',$val);
			$content.=str_replace(array_keys($val),array_values($val),$linkTmpl);
		}


		$res=$TYPO3_DB->exec_SELECTgetRows(
			'referer_full,referer_resolved',
			'tx_ppstats_usertrack',
			'site_index='.$this->site_index.' AND firstconnection>='.$startTime.' AND firstconnection<'.$endTime
			);

		$categs=$TYPO3_DB->exec_SELECTgetRows(
			'*',
			'tx_ppstats_categ',
			'1'.t3lib_pageSelect::enableFields('tx_ppstats_categ')
			);

		$content.='<h3>'.$this->getLL('referer.count').'</h3>';
		$countArr=array();
		foreach ($res as $row) {
			$find=FALSE;
			foreach ($categs as $cat) {
				if ($cat['refererfull']) {
					$theField=strtolower($row['referer_full']);
				} else {
					$theField=strtolower($row['referer_resolved']);
				}

				if ($cat['ereg'] && trim($cat['referer'])) {
					$find=ereg(strtolower($cat['referer']),$theField);
				} else {
					$find=($theField==strtolower($cat['referer']));
				}

				if ($find) {
					$countArr[$cat['cat']]++;
					break;
				}
			}
			if (!$find) {
					$countArr['<i>'.strtolower($row['referer_resolved']).'</i>']++;
			}
		}

		unset($res);
		unset($categs);

		$content.='<table><tr><th style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('referer.categ').'</th><th style="background: '.$this->pObj->doc->bgColor2.';">'.$this->getLL('referer.count').'</th></tr>';
		foreach ($countArr as $key=>$val) {
			$content.='<tr><td style="background: '.$this->pObj->doc->bgColor4.';">'.$key.'</td><td style="background: '.$this->pObj->doc->bgColor4.';">'.htmlspecialchars($val).'</td></tr>';
		}
		$content.='</table>';

		return $content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function printMostVisited() {
		/* Declare */
		$content='';
		$startTime=0;
		$endTime=0;
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	
		global $TYPO3_DB;
		$top=0;
	
		/* Begin */

		if (trim($this->data['start'])) {
			list($day,$month,$year)=explode('/',$this->data['start']);
			$startTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$startTime) {
			$startTime=$currentDay-(20*24*3600);
			$this->data['start']=date('d/m/Y',$startTime);
		}

		if (trim($this->data['stop'])) {
			list($day,$month,$year)=explode('/',$this->data['stop']);
			$endTime=mktime(0,0,0,$month,$day,$year);
		}
		if (!$endTime) {
			$this->data['stop']=date('d/m/Y',$currentDay+(24*3600));
			$endTime=$currentDay+(24*3600);
		}

		if (!($top=$this->data['nbtop']=intval($this->data['nbtop']))) {
			$top=$this->data['nbtop']=5;
		}

		$content.='<h3>'.$this->getLL('mostVisited.formLabel').'</h3>';
		$content.='<table>';
		$content.='<tr><td>'.$this->getLL('mostVisited.start').'</td><td><input type="text" name="data[start]" value="'.htmlspecialchars($this->data['start']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('mostVisited.stop').'</td><td><input type="text" name="data[stop]" value="'.htmlspecialchars($this->data['stop']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('mostVisited.nbtop').'</td><td><input type="text" name="data[nbtop]" value="'.htmlspecialchars($this->data['nbtop']).'" /></td></tr>';
		$content.='<tr><td><input type="submit" value="&gt;" /></td><td>&nbsp;</td>';
		$content.='</table>';


		$res=$TYPO3_DB->exec_SELECTgetRows(
			'title,url,abs_url,count(*) AS visites',
			'tx_ppstats_pageaccess',
			'site_index='.$this->site_index.' AND crdate>='.$startTime.' AND crdate<'.$endTime,
			'pid',
			'visites DESC,abs_url',
			$top
			);

		$content.='<h3>'.$this->getLL('mostVisited.pages').'</h3>';
		//t3lib_div::debug($res, '');
		foreach ($res as $key=>$val) {
			$prefix='';
			if ($val['abs_url']) {
				$temp=parse_url($val['abs_url']);
				$prefix=$temp['scheme']?($temp['scheme'].'://'):'http://';
			}
			$prefix.=$temp['host'];
			$content.=($key+1).'. <a href="'.htmlspecialchars($prefix.$val['url']).'">'.htmlspecialchars($val['title']).' :</a> '.sprintf($this->getLL('mostVisited.visites'),$val['visites']).'<br />';
		}


		return $content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function printDetail() {
		/* Declare */
		$content='<div>';
		$date=0;
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	
	
		/* Begin */
		if (trim($this->data['date'])) {
			list($day,$month,$year)=explode('/',$this->data['date']);
			$date=mktime(0,0,0,$month,$day,$year);
		}
		if (!$date) {
			$this->data['date']=date('d/m/Y',$this->getTime());
			$date=$currentDay;
		}

		if (!($step=$this->data['step']=intval($this->data['step'])) || !in_array($step,array(1,2,3,4,6,8,12,24))) {
			$step=$this->data['step']=4;
		}


		//t3lib_div::debug($date, '');


		$content.='<h3>'.$this->getLL('detail.formLabel').'</h3>';
		$content.='<table>';
		$content.='<tr><td>'.$this->getLL('detail.date').'</td><td><input type="text" name="data[date]" value="'.htmlspecialchars($this->data['date']).'" /></td></tr>';
		$content.='<tr><td>'.$this->getLL('detail.step').'</td><td><select name="data[step]">';
		foreach (array(1,2,3,4,6,8,12,24) as $val) {
			$content.='<option value="'.$val.'"'.(($val==$this->data['step'])?' selected="selected"':'').'>'.$val.' h</option>';
		}
		$content.='</select></td></tr>';
		$content.='<tr><td><input type="submit" value="&gt;" /></td><td>&nbsp;</td>';
		$content.='</table>';


		$content.='<h3>'.$this->getLL('detail.detail').'</h3>';
		$content.=$this->detailUser($date,$step);

		return $content.$this->printScript();
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function getPresets($special='') {
		/* Declare */
		$presets=array();
		$currentDay=mktime(0,0,0,date('m',$this->getTime()),date('d',$this->getTime()),date('Y',$this->getTime()));	
	
		/* Begin */
		//*** Last 7 days Week
		$presets[]=array(
			'###start###'=>rawurlencode(date('d/m/Y',$currentDay-(6*24*3600))),
			'###stop###'=>rawurlencode(date('d/m/Y',$currentDay+(24*3600))),
			'###step###'=>1,
			'###label###'=>$this->getLL('allPresets.preset.7days')
			);
		//*** Last 30 days
		$presets[]=array(
			'###start###'=>rawurlencode(date('d/m/Y',$currentDay-(29*24*3600))),
			'###stop###'=>rawurlencode(date('d/m/Y',$currentDay+(24*3600))),
			'###step###'=>1,
			'###label###'=>$this->getLL('allPresets.preset.30days')
			);

		switch ($special){
		default:
			break;
		}
		/*
		$presets[]=array(
			'###start###'=>rawurlencode(date('d/m/Y',$currentDay)),
			'###stop###'=>rawurlencode(date('d/m/Y',$currentDay)),
			'###step###'=>1,
			'###label###'=>$this->getLL('period.preset.')
			);
		*/

		return $presets;
	}


	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function printMenu() {
		return t3lib_BEfunc::getFuncMenu(
			$this->pObj->id,
			'SET[pp_stats_type]',
			$this->pObj->MOD_SETTINGS['pp_stats_type'],
			$this->pObj->MOD_MENU['pp_stats_type'],
			'index.php'
			).'<input type="hidden" name="data[keepPid]" value="'.$this->pid.'" />';
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function detailUser($startDay,$partSize=6) {
		/* Declare */
		global $TYPO3_DB;
		$after=0;
		$before=0;
		$data=array();
		
		$nbparts=24/$partSize;

		$partMenu=array('');
		$content='';
	
		/* Begin */
		for ($i=0;$i<$nbparts;$i++) {
			$partMenu[]=($i*$partSize).'h - '.(($i+1)*$partSize).'h';
			
			$after=$startDay+(($i*$partSize)*3600);
			$before=$startDay+((($i+1)*$partSize)*3600);

			$content.='<div id="hour-part-'.($i+1).'" style="display: none;">';

			$res=$TYPO3_DB->exec_SELECTgetRows(
				'*',
				'tx_ppstats_usertrack',
				'site_index='.$this->site_index.' AND firstconnection>='.($after).' AND firstconnection<'.$before
				);

			foreach ($res as $row) {
				$content.=$this->displayUserDetails($row);
			}


			$content.='</div>';
		}

		$menu.='<select onchange="pp_stats_changePart(this);">';
		foreach ($partMenu as $key=>$val) {
			$menu.='<option value="'.$key.'">'.$val.'</option>';
		}
		$menu.='</select><br />';

		return $menu.$content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function buildTSFE() {
		/* Declare */
		$temp_TSFEclassName = t3lib_div::makeInstanceClassName('tslib_fe');
	
		/* Begin */
		if (!is_object($GLOBALS['TT'])) {
			$GLOBALS['TT'] = new t3lib_timeTrack;
			$GLOBALS['TT']->start();
		}

		if (!is_object($GLOBALS['TSFE']) && $this->pid) {
			//*** Builds TSFE object
			$GLOBALS['TSFE'] = new $temp_TSFEclassName($GLOBALS['TYPO3_CONF_VARS'],$this->pid,0,0,0,0,0,0);

			//*** Builds sub objects
			$GLOBALS['TSFE']->tmpl = t3lib_div::makeInstance('t3lib_tsparser_ext');
			$GLOBALS['TSFE']->sys_page = t3lib_div::makeInstance('t3lib_pageSelect');

			//*** init template
			$GLOBALS['TSFE']->tmpl->tt_track = 0;// Do not log time-performance information
			$GLOBALS['TSFE']->tmpl->init();
			
			$rootLine = $GLOBALS['TSFE']->sys_page->getRootLine($this->pid);

			//*** This generates the constants/config + hierarchy info for the template.
			$GLOBALS['TSFE']->tmpl->runThroughTemplates($rootLine,$template_uid);
			$GLOBALS['TSFE']->tmpl->generateConfig();
			$GLOBALS['TSFE']->tmpl->loaded=1;

			//*** Get config array and other init from pagegen
			$GLOBALS['TSFE']->getConfigArray();
			$GLOBALS['TSFE']->linkVars = ''.$GLOBALS['TSFE']->config['config']['linkVars'];

			if ($GLOBALS['TSFE']->config['config']['simulateStaticDocuments_pEnc_onlyP'])	{
				foreach (t3lib_div::trimExplode(',',$GLOBALS['TSFE']->config['config']['simulateStaticDocuments_pEnc_onlyP'],1) as $temp_p)	{
					$GLOBALS['TSFE']->pEncAllowedParamNames[$temp_p]=1;
				}
			}

			//*** Builds a cObj
			$GLOBALS['TSFE']->newCObj();
		}

	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function displayUserDetails($row) {
		/* Declare */
		global $TYPO3_DB;
		$content='<table style="border: 1px solid black;">';
	
		/* Begin */
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">uid</th><td style="background: '.$this->pObj->doc->bgColor4.';">'.$row['uid'].'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">IP</th><td style="background: '.$this->pObj->doc->bgColor4.';">'.$row['client_ip'].'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Navigateur (indication)</th><td style="background: '.$this->pObj->doc->bgColor4.';">'.$this->renderBrowser($row['user_agent_resolved']).'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Langue </th><td style="background: '.$this->pObj->doc->bgColor4.';">'.reset(split('[,;]',$row['accept_language'])).'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Date premiere connection </th><td style="background: '.$this->pObj->doc->bgColor4.';">'.date('d/m/Y H:i:s',$row['firstconnection']).'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Date derniere connection </th><td style="background: '.$this->pObj->doc->bgColor4.';">'.date('d/m/Y H:i:s',$row['lastconnection']).'</td>';
		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Arriv par</th><td style="background: '.$this->pObj->doc->bgColor4.';">'.$row['referer_resolved'].'</td>';

		$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Pages visites</th><td style="background: '.$this->pObj->doc->bgColor4.';">';

		$pages=$TYPO3_DB->exec_SELECTgetRows('abs_url,url,title,crdate','tx_ppstats_pageaccess','user_id='.intval($row['uid']));
		foreach ($pages as $val) {

			$content.='<a href="'.(trim($val['abs_url'])?htmlentities($val['abs_url']):($GLOBALS['BACK_PATH'].'..'.htmlentities($val['url']))).'">'.$val['title'].'</a> ('.date('d/m/Y H:i:s',$val['crdate']).')<br />';
		}
		$content.='</td>';
			

		if ($row['fe_user']) {
			$content.='<tr><th style="background: '.$this->pObj->doc->bgColor2.';">Utilisateur</th><td style="background: '.$this->pObj->doc->bgColor4.';">'.$this->renderFeUserField($row['fe_user']).'</td>';
		}


		return $content.'</table>';
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function renderFeUserField($value) {
		/* Declare */
		global $TYPO3_DB;
		$res=FALSE;
		$user=array();
		$content='';
	
		/* Begin */
		if ($value && ($res=$TYPO3_DB->exec_SELECTgetRows('*','fe_users','uid='.$value)) && count($res)) {
			$user=reset($res);
			$content='<a target="_blank" href="'.$GLOBALS['BACK_PATH'].'alt_doc.php?edit[fe_users]['.$value.']=edit&returnUrl=">';
			$content.=($user['name'])?$user['name']:$user['username'];
			$content.='</a>';
		}

		return $content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function renderBrowser($info) {
		/* Declare */
		$parts=explode(';',$info);
		$content=(trim($parts[0])?$parts[0]:'unknown browser').(trim($parts[1])?' v '.$parts[1]:'');
	
		/* Begin */
		if (trim($parts[2])) {
			$content.=' (<a href="'.htmlspecialchars($parts[2]).'">Infos</a>)';
		}
		return $content;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function userLastXDays($days) { //OBSOLETE
		/* Declare */
		list($year,$month,$day)=explode('/',date('Y/m/d', $this->getTime()));
		$data=array();
		$startDay=mktime(0,0,0, $month, $day, $year);
		global $TYPO3_DB;

		/* Begin */
		for ($i=0;$i<$days;$i++) {
			$after=$startDay-(($i)*24*3600);
			$before=$after+(24*3600);

			$res=$TYPO3_DB->exec_SELECTgetRows(
				'tx_ppstats_usertrack.uid,count(*) AS counter',
				'tx_ppstats_usertrack LEFT JOIN tx_ppstats_pageaccess ON (tx_ppstats_pageaccess.user_id=tx_ppstats_usertrack.uid)',
				'tx_ppstats_usertrack.site_index='.$this->site_index.' AND tx_ppstats_usertrack.firstconnection>='.$after.' AND tx_ppstats_usertrack.firstconnection<'.$before,
				'tx_ppstats_usertrack.uid'
				);

			$temp=array('user'=>0,'pages'=>0);
			foreach ($res as $val) {
				$temp['user']++;
				$temp['pages']+=$val['counter'];
			}

			$data[$i]=$temp;
		}
		krsort($data);

		foreach ($data as $key=>$val) {
			if ($key) {
				$row1.='<td>Il y a '.$key.' jour(s)</td>';
			} else {
				$row1.='<td>Aujourd\'hui</td>';
			}
			$row2.='<td>'.$val['user'].'</td>';
			$row3.='<td>'.$val['pages'].'</td>';
		}

		return '<table style="border: solid 1px black;"><tr><td>&nbsp;</td>'.$row1.'</tr><tr><td>Utilisateurs</td>'.$row2.'</tr><tr><td>Pages vues</td>'.$row3.'</tr></table>';
	}

	function getTime() {
		return $GLOBALS['SIM_EXEC_TIME'];
	}


	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function getPidList($pid) {
		global $TYPO3_DB;
		$result=array($pid);

		$res=$TYPO3_DB->exec_SELECTgetRows(
			'uid',
			'pages',
			'pid='.((string)$pid).t3lib_BEfunc::deleteClause('pages')
			);

		foreach ($res as $val) {
			foreach ($this->getPidList($val['uid']) as $val2) {
				$result[]=$val2;
			}
		}

		return $result;
	}

	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function printScript() {
		/* Declare */
	
		/* Begin */
		return '
<script type="text/javascript">
/*<![CDATA[*/
<!--

function pp_stats_changePart(obj){
	curIndex=obj.options[obj.options.selectedIndex].value;
	
	var i=1;
	var temp=null;
	while(temp=document.getElementById(\'hour-part-\'+i)){
		if((\'\'+i)==curIndex){
			temp.style.display=\'\';
		} else{
			temp.style.display=\'none\';
		}
		i++;
	}
}

// -->
/*]]>*/
</script>
';
	}



	/**
	 *
	 *
	 * @param 
	 * @access public
	 * @return void 
	 */
	function getLL($str) {
		return nl2br(htmlspecialchars($GLOBALS['LANG']->sL('LLL:EXT:pp_stats/modfunc1/locallang.php:'.$str)));
	}


}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pp_stats/modfunc1/class.tx_ppstats_modfunc1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pp_stats/modfunc1/class.tx_ppstats_modfunc1.php']);
}

?>